
// Variabelen voor extern gebruik:
bool LijnSensorCalibrated = false;  
int LijnSensorData[6];
unsigned char LijnSensorBits;    // bit 0 t/m 6 = sensor 0 t/m 6
unsigned char LijnSensorCurrent;  // positie lijn 0...11, laatste resultaat 
unsigned char LijnSensorOutput;  // positie lijn 0...11, gebufferd als we de lijn kwijt zijn.
bool LijnSensorValid;            // true als we de lijn zien. 

// Variabelen voor inter gebruik:
int LijnSensorDataRaw[6];
int LsCalibrationData[6];
int LsMinimum;
bool LsCalibrationInProgress = false;

//D:\MyRobot\arm\fbot\linesensor>perl linesensor.pl 
//line sensor table generation
const char LijnSensorMidden[] = {  0 ,  1 ,  3 ,  2 ,  5 ,  3 ,  4 ,  3 ,  7 ,  4 ,  5 ,  4 ,  6 ,  4 ,  5 ,  4 ,  9 ,  5 ,  6 ,  4 ,  7 ,  5 ,  6 ,  5 ,  8 ,  6 ,  6 ,  5 ,  7 ,  6 ,  6 ,  5 , 
                     11 ,  6 ,  7 ,  5 ,  8 ,  6 ,  6 ,  5 ,  9 ,  6 ,  7 ,  6 ,  8 ,  6 ,  7 ,  5 , 10 ,  7 ,  8 ,  6 ,  8 ,  7 ,  7 ,  6 ,  9 ,  7 ,  8 ,  6 ,  8 ,  7 ,  7 ,  6 };

const char LijnSensorLinks[] = {  0 ,  1 ,  3 ,  2 ,  5 ,  5 ,  4 ,  4 ,  7 ,  7 ,  7 ,  7 ,  6 ,  6 ,  6 ,  6 ,  9 ,  9 ,  9 ,  9 ,  9 ,  9 ,  9 ,  9 ,  8 ,  8 ,  8 ,  8 ,  8 ,  8 ,  8 ,  8 , 
                     11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 11 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 , 10 };

const char LijnSensorRechts[] = {  0 ,  1 ,  3 ,  2 ,  5 ,  1 ,  4 ,  2 ,  7 ,  1 ,  3 ,  2 ,  6 ,  1 ,  4 ,  2 ,  9 ,  1 ,  3 ,  2 ,  5 ,  1 ,  4 ,  2 ,  8 ,  1 ,  3 ,  2 ,  6 ,  1 ,  4 ,  2 , 
                     11 ,  1 ,  3 ,  2 ,  5 ,  1 ,  4 ,  2 ,  7 ,  1 ,  3 ,  2 ,  6 ,  1 ,  4 ,  2 , 10 ,  1 ,  3 ,  2 ,  5 ,  1 ,  4 ,  2 ,  8 ,  1 ,  3 ,  2 ,  6 ,  1 ,  4 ,  2 };


void LijnSensorPrint()
{ 
  printf("LsRaw %d %d %d %d %d %d\n", 
  LijnSensorDataRaw[0], LijnSensorDataRaw[1], LijnSensorDataRaw[2], LijnSensorDataRaw[3], LijnSensorDataRaw[4], LijnSensorDataRaw[5]);

//  printf("LsCalData %d %d %d %d %d %d\n", 
//  LsCalibrationData[0], LsCalibrationData[1], LsCalibrationData[2], LsCalibrationData[3], LsCalibrationData[4], LsCalibrationData[5]);

//  printf("LijnSensor %d %d %d %d %d %d [%d 0x%02x ] \n", 
//  LijnSensorData[0], LijnSensorData[1], LijnSensorData[2], LijnSensorData[3], LijnSensorData[4], LijnSensorData[5], LijnSensorOutput, LijnSensorBits);
  
}


void LijnSensorTakt()
{
  digitalWrite(LIJNSENSOR_LED, 1);  // leds aan
  delay(2);                         // even wachten
  LijnSensorDataRaw[0] = analogRead(A3);
  LijnSensorDataRaw[1] = analogRead(A2);
  LijnSensorDataRaw[2] = analogRead(A1);
  LijnSensorDataRaw[3] = analogRead(A0);
  LijnSensorDataRaw[4] = analogRead(A6);
  LijnSensorDataRaw[5] = analogRead(A7);
  digitalWrite(LIJNSENSOR_LED, 0);  // leds weer uit

  if (LsCalibrationInProgress){
    for (int i=0; i<6; i++) {
      // bepaal min en max
      if (LijnSensorDataRaw[i] > LsCalibrationData[i]) LsCalibrationData[i] = LijnSensorDataRaw[i];
      if (LijnSensorDataRaw[i] < LsMinimum) LsMinimum = LijnSensorDataRaw[i];   
    }
  } 
  else {
    LijnSensorBits = 0;
    int BitValue = 1;
    for (int i=0; i<6; i++) {
      
      // normaliseer waarden tussen 0 en 100
      LijnSensorData[i] = (LijnSensorDataRaw[i] - LsMinimum) * 100L / LsCalibrationData[i];
      if (LijnSensorData[i] <   0) LijnSensorData[i] =   0;
      if (LijnSensorData[i] > 100) LijnSensorData[i] = 100;
      
      // Bepaal LineSensorBits en positie lijn
      if (LijnSensorData[i] > 40) {
        LijnSensorBits += BitValue;
      }
      BitValue *= 2;
    }
    LijnSensorCurrent = LijnSensorMidden[LijnSensorBits];      
    if (LijnSensorCurrent) {
      LijnSensorValid = true;
      LijnSensorOutput = LijnSensorCurrent;
    } else {
      LijnSensorValid = false;
   }                                     
    
  }
}

void LsCalibrationStart()
{
  LsMinimum = 1023;
  for (int i=0; i<6; i++) LsCalibrationData[i]= 0;
  LsCalibrationInProgress = true;
}

void LsCalibrationEnd()
{
  for (int i=0; i<6; i++) LsCalibrationData[i] -= LsMinimum;
  LsCalibrationInProgress = false;
}

