//-----------------------------------------------------------------------------
// Motors.ino - 
//-----------------------------------------------------------------------------

// Constantes
const int  HL_PWMR = 9;
const int  HL_PWML = 10;  

//-----------------------------------------------------------------------------
// SetupMotors - Stel IO in voor aansturing motoren
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void SetupMotors()
{
  // Pwm pins
  pinMode(HL_PWML, OUTPUT);   
  pinMode(HL_PWMR, OUTPUT);   

  // zet output op 0 via Motors()
  Motors(0, 0);
}

//------------------------------------------------------------------------------
// Motors - Stel PWM duty cycle  + rijrichtging in voor beide motoren
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Motors(int PowerL, int PowerR) 
{
  if (BatterijLowFlag) {
    // Blokkeer motoren als batterijspanning te laag is.
    PowerL = 0;
    PowerR = 0;
  }
  
  //--------
  // Motor L 
  //--------

  // begrens waarden
  if (PowerL >  255) { 
    PowerL =  255; 
  }
  if (PowerL < -255) { 
    PowerL = -255; 
  }  

  // Set PWM en richting  
  if (PowerL >= 0) {
    PCF8574DataOut = (PCF8574DataOut & 0xF3) | 4;  // vooruit
    analogWrite(HL_PWML, PowerL);    
  } 
  else {
    PCF8574DataOut = (PCF8574DataOut & 0xF3) | 8;  // achteruit
    analogWrite(HL_PWML, -PowerL); 
  }

  //--------
  // Motor R
  //--------

  // begrens waarden
  if (PowerR >  255) { 
    PowerR =  255; 
  }
  if (PowerR < -255) { 
    PowerR = -255; 
  }

  //Set PWM en richting  
  if (PowerR >= 0) {
    PCF8574DataOut = (PCF8574DataOut & 0xFC) | 2;  // vooruit    
    analogWrite(HL_PWMR, PowerR);    
  } 
  else {
    PCF8574DataOut = (PCF8574DataOut & 0xFC) | 1;  // achteruit
    analogWrite(HL_PWMR, -PowerR); 

  }
}




